#include <stdint.h>
#include <stdio.h>
#include <string.h> 
#include <math.h>
#include <stdlib.h>
#include <util/delay.h>
#include "receive.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>
/*baudrate=38400*/
#define baud               7
/*baudrate=9600*/
//#define baud               32 
#define USART1_RX_vect			_VECTOR(32)
#define SIG_UART1_RECV			_VECTOR(32)
#define BUFFER_LENGHT    1200


char tempstr[10];
/*the formula for calculate the UBBR0 value is 
 *  UBBR0= F_CPU/(16*baud)-1
*/
void USART0_Init (void){
	uint8_t intstate = SREG;
	cli();

	while(0<<TXC0){
	}
	/* set baud rate*/
	UBRR0H = (uint8_t)(baud>>8);
	UBRR0L = (uint8_t)(baud);

	/* set frame format: I wil set it now as 8 bits, no parity 1 stop bit, asynchron*/
	UCSR0C = (0<<UMSEL0)|(0<<UPM0)|(0<<USBS0)|(3<<UCSZ0);
	/*Enable receiver and transmitter; enable RX interrupt*/
	UCSR0B = (1<<TXEN0)|(1<<RXEN0)|(1<<RXCIE0);
	//UCSR0B = (1<<TXEN0)|(1<<RXEN0)|(0<<RXCIE0);
	sprintf(tempstr, "UBRR0H: 0x%x,UBRR0L: 0x%x", UBRR0H,UBRR0L);
	break_point(tempstr, __LINE__);
	SREG=intstate;
}


void  USART0_Transmit(unsigned char c) {
// 	sprintf(tempstr, "UDR0 transmitt: %c", UDR0);
// 	break_point(tempstr, __LINE__);
// wait until UDR ready
	while(!(UCSR0A & (1 << UDRE0)))
	{
		/* do nothing*/
	}
	UDR0 = c;    // send character
	sprintf(tempstr, "UDR0 transmitt: %c", UDR0);
	break_point(tempstr, __LINE__);
	return;

}
// SIGNAL can't be interrupted
SIGNAL (SIG_UART0_RECV) {  
	
	char string[100];
	unsigned char c;
	int i=0;
	

 		for(int i=0; i<BUFFER_LENGHT;i++)
		{
	
			
 			while ( ! (UCSR0A & (1<<RXC0)))
 			{
				/* do nothing*/
			}
			
			c=UDR0;
			if (c!='\r')	
			{
				string[i]=c;

  				snprintf(tempstr, 20, "char: %x, string: %s", string[i], string);
				break_point(tempstr, __LINE__);
				//USART0_Transmit(c);
			}
			else
			UCSR0B = ~(1<<RXCIE0);
			return;
// 			snprintf(tempstr, 20, "char: %x, string: %s", string[i], string);
// 			break_point(tempstr, __LINE__);	
 		}
		
 }
	
char LED_print(char digit, char ASCII_data)
{
    
	char    Data_var;
	//char tempstr[10];
  
	if( !digit == 1 )
		     
		return 0; 
	else
	{
		switch(ASCII_data )    //Find output pattern according to input
		{ 
			case    '0':    Data_var = 0x24;
			break;  
			case    '1':    Data_var = 0x3F;
			break;
			case    '2':    Data_var = 0x62;  
			break;
			case    '3':    Data_var = 0x2A;
			break;
			case    '4':    Data_var = 0xB1;  
			break;
			case    '5':    Data_var = 0xA8;
			break;
			case    '6':    Data_var = 0xA0;  
			break;
			case    '7':    Data_var = 0x3E;
			break;
			case    '8':    Data_var = 0x20;  
			break;
			case    '9':    Data_var = 0x38;
			break;
			case    'A':    Data_var = 0x30;
			break;
			case    'B':    Data_var = 0xA1;  
			break;
			case    'C':    Data_var = 0xE4;
			break;
			case    'D':    Data_var = 0x23;  
			break;
			case    'E':    Data_var = 0xE0;
			break;
			case    'F':    Data_var = 0xF0;
			break;
			
			default:        return 0;            /* Returns 0 if input argument 
			ASCII_data is out of range */                  
		}
	}    
	if(digit == 1)
	{
		LED.digit1 = Data_var;             
		
	
		return 1;                           
	}
}


void LED_update(void)
{
	
	DDRC =  0xFF;
	PORTC = 0x00;
	PORTC = LED.digit1;                    //Writes outputs to segments
		
	sprintf(tempstr, "PortC:ausgang 0x%x", PORTC);
	//break_point(tempstr, 0);
}
void break_point(char *str, uint8_t v) 
{
	int a,b=10;
	a=b+2+v;

	return;

}


